
// Step 1: Check if the client is new or returning
var clientType = localStorage.getItem("clientType");
var visitNumber = localStorage.getItem("visitNumber");

if (!clientType) {
  // If the clientType is not set, it means it's a new client
  // Set clientType to "new" and initialize visitNumber to 1
    clientType = "new";
    visitNumber = 1;
    localStorage.setItem("visitNumber", visitNumber);
    localStorage.setItem("clientType", clientType);
} else {
    if (clientType === "new") {
        clientType = "returned";
        localStorage.setItem("clientType", clientType);
    }
}

// Step 2: Check if the session is new or returning
var sessionType = sessionStorage.getItem("sessionType");

if (!sessionType) {
  // If the sessionType is not set, it means it's a new session
  // Set sessionType to "new"
    sessionType = "new";
    sessionStorage.setItem("sessionType", sessionType);
    let sessionStartTime = new Date().getTime(); // setting the session start time
	sessionStorage.setItem("sessionStartTime", sessionStartTime); 
	// Инициализируем eventsSent в sessionStorage, если он еще не был установлен
if (!sessionStorage.getItem("eventsSent")) {
    sessionStorage.setItem("eventsSent", JSON.stringify({
        "1_minute_on_site": false,
        "3_minute_on_site": false,
        "6_minute_on_site": false,
        "9_minute_on_site": false
    }));
}
} else {
    if (sessionType === "new") {
        sessionType = "returned";
        sessionStorage.setItem("sessionType", sessionType);
    }
}

// Step 6: Increase visit number if there is an external referrer
if (clientType === "returned" && sessionType === "new" && document.referrer !== "" && new URL(document.referrer).hostname !== window.location.hostname) {
    // If the client is returning, the session is new, and there is an external referrer
    // increase the visitNumber by 1
    visitNumber = parseInt(localStorage.getItem("visitNumber")) || 0;
    visitNumber++;
    localStorage.setItem("visitNumber", visitNumber);
}

// Step 7: Increase visit number if clientType "returned" and sessionType "new"
if (clientType === "returned" && sessionType === "new") {
  // If the client is returning and the session is new, increase the visitNumber by 1
    visitNumber = parseInt(localStorage.getItem("visitNumber")) || 0;
    visitNumber++;
    localStorage.setItem("visitNumber", visitNumber);
}

if (sessionType === "new") {
  // If the client is returning and the session is new, increase the visitNumber by 1
    pageViewSession = 0;
    pageViewSession++;
    localStorage.setItem("pageViewSession", pageViewSession);
}

if (sessionType === "returned") {
  // If the client is returning and the session is new, increase the visitNumber by 1
    pageViewSession = parseInt(localStorage.getItem("pageViewSession")) || 0;;
    pageViewSession++;
    localStorage.setItem("pageViewSession", pageViewSession);
}

// Step 8: Count pageviews and store in localStorage
var pageViewCount = parseInt(localStorage.getItem("pageViewCount")) || 0;
pageViewCount++;
localStorage.setItem("pageViewCount", pageViewCount);

  
// Step 3: Collect data about the user
var userData = {
    counterID: "", // A unique identifier for the counter (could be an actual ID in production)
    clientType: localStorage.getItem("clientType"),
    sessionType: sessionStorage.getItem("sessionType"),
    pageView: localStorage.getItem("pageViewCount"),
    pageViewSession: localStorage.getItem("pageViewSession"),
    referrer: document.referrer, // The URL of the referring page
    userAgent: navigator.userAgent, // The user agent string of the browser
    currentURL: window.location.origin + window.location.pathname, // The current URL
    title: document.title, // The title of the current page
    timeStamp: new Date(new Date().getTime() + 180 * 60000).toISOString(), // The current timestamp
    events: {}, // Placeholder for events data (to be populated later)
    utm: {}, // Placeholder for UTM parameters (to be populated later)
    pageName: "not_set", // The name of the page (could be an actual name in production)
    visitNumber: visitNumber // The current visit number
};

// Step 4: Collect UTM parameters
function getParameterByName(name) {
    var url = window.location.href;
    name = name.replace(/[\[\]]/g, "\\$&");
    var regex = new RegExp("[?&]" + name + "(=([^&#]*)|&|#|$)"),
        results = regex.exec(url);
    if (!results) return null;
    if (!results[2]) return "";
    return decodeURIComponent(results[2].replace(/\+/g, " "));
}
// Collect UTM parameters from the URL and add them to the userData object
var utm_source = getParameterByName("utm_source");
var utm_medium = getParameterByName("utm_medium");
var utm_campaign = getParameterByName("utm_campaign");
var utm_term = getParameterByName("utm_term");
var utm_content = getParameterByName("utm_content");
if (utm_source) userData.utm.source = utm_source;
if (utm_medium) userData.utm.medium = utm_medium;
if (utm_campaign) userData.utm.campaign = utm_campaign;
if (utm_term) userData.utm.term = utm_term;
if (utm_content) userData.utm.content = utm_content;

// Step 5: Send data to server
function sendData(data, eventName, eventValue, counterID) {
   // Store the event name and value in the userData object
   userData.events.name = eventName;
   userData.events.value = eventValue;
   userData.counterID = counterID;

   // Send the data to the server using a POST request
   fetch("https://functions.yandexcloud.net/d4ehakkcdlmac3s7osrs", {
       method: "POST",
       body: JSON.stringify(data),
       headers: {
           'Content-Type': 'application/json'
       }
   })
   .then(function(response) {
       console.info("Data sent successfully");
   })
   .catch(function(error) {
       console.error("Error sending data: " + error);
   });
}

var domain = window.location.hostname;

// ”даление префикса "www" из домена
if (domain.startsWith("www.")) {
  domain = domain.replace("www.", "");
}

// »спользование обновленного домена
var cID = getCounterIdByDomain(domain);

// ‘ункци¤ дл¤ получени¤ counterId по домену
function getCounterIdByDomain(domain) {
    // counterId дл¤ каждого домена
    switch (domain) {
        case "xn--80aadf5brnhj.xn--p1ai":
            return "2881268";
		case "aerius.pro":
            return "6357271";
        case "pro-gemorroy.info":
            return "8548289";
		case "elevit.ru":
            return "6039282";
		case "aspirin.ru":
            return "7097867";
        default:
            return "0000001";
    }
}

// —обытие, срабатывающее через 15 секунд после загрузки страницы:
setTimeout(function() {
    sendData(userData, "time", "15_second_event", cID);
}, 15000);

// —обыти¤ по скроллу с квартил¤ми (25%, 50%, 75%)

var hasTriggered25Percent = false;
var hasTriggered50Percent = false;
var hasTriggered75Percent = false;
var hasTriggered95Percent = false;

var trackScroll = function() {
   var pageHeight = document.documentElement.scrollHeight;
   var windowHeight = window.innerHeight;
   var scrollPosition = window.pageYOffset || document.documentElement.scrollTop || document.body.scrollTop;

   var quarterHeight = pageHeight / 4;
   var scrollTopPercentage = Math.floor((scrollPosition / (pageHeight - windowHeight)) * 100);

   if (!hasTriggered25Percent && scrollTopPercentage >= 25) {
      sendData(userData, "scroll", "25", cID);
      hasTriggered25Percent = true;
   } else if (!hasTriggered50Percent && scrollTopPercentage >= 50) {
      sendData(userData, "scroll", "50", cID);
      hasTriggered50Percent = true;
   } else if (!hasTriggered75Percent && scrollTopPercentage >= 75) {
      sendData(userData, "scroll", "75", cID);
      hasTriggered75Percent = true;
   } else if (!hasTriggered95Percent && scrollTopPercentage >= 95) {
      sendData(userData, "scroll", "95", cID);
      hasTriggered95Percent = true;
      // ќстановка отслеживани¤ скролла после достижени¤ 95%
      window.removeEventListener("scroll", trackScroll);
   }
};

window.addEventListener("scroll", trackScroll);

// time check
function checkTimeSpent() {
    let currentTime = new Date().getTime();
    let timeSpent = (currentTime - Number(sessionStorage.getItem("sessionStartTime"))) / 1000; // converting milliseconds to seconds
    let eventsSent = JSON.parse(sessionStorage.getItem("eventsSent"));

    if (timeSpent >= 60 && timeSpent < 180 && !eventsSent["1_minute_on_site"]) {
        sendData(userData, "time", "1_minute_on_site", cID);
        eventsSent["1_minute_on_site"] = true;
        sessionStorage.setItem("eventsSent", JSON.stringify(eventsSent));
    }

    if (timeSpent >= 180 && timeSpent < 360 && !eventsSent["3_minute_on_site"]) {
        sendData(userData, "time", "3_minute_on_site", cID);
        eventsSent["3_minute_on_site"] = true;
        sessionStorage.setItem("eventsSent", JSON.stringify(eventsSent));
    }

    if (timeSpent >= 360 && timeSpent < 540 && !eventsSent["6_minute_on_site"]) {
        sendData(userData, "time", "6_minute_on_site", cID);
        eventsSent["6_minute_on_site"] = true;
        sessionStorage.setItem("eventsSent", JSON.stringify(eventsSent));
    }

    if (timeSpent >= 540 && timeSpent < 660 && !eventsSent["9_minute_on_site"]) {
        sendData(userData, "time", "9_minute_on_site", cID);
        eventsSent["9_minute_on_site"] = true;
        sessionStorage.setItem("eventsSent", JSON.stringify(eventsSent));
    }

    if (timeSpent < 600) { // Если время меньше 10 минут, продолжаем проверку
        setTimeout(checkTimeSpent, 60000); // check every minute
    }
};

checkTimeSpent();


if (cID === "7097867" || cID === "6039282") {
    // “рекинг видео
    var video = document.getElementsByTagName("video")[0];

	if (video) {
    // Если элемент найден, вешаем на него слушатель
    video.addEventListener('play', function() {
        sendData(userData, "video", "start", cID);
    }, { once: true });

    var watchedQuartiles = { first: false, second: false, third: false, fourth: false };

    video.addEventListener('timeupdate', function() {
        const duration = video.duration;
        const currentTime = video.currentTime;
        // Проверка на квартили
        if (!watchedQuartiles.first && currentTime >= (0.25 * duration)) {
            sendData(userData, "video", "25", cID);
            watchedQuartiles.first = true;
        }
        if (!watchedQuartiles.second && currentTime >= (0.50 * duration)) {
            sendData(userData, "video", "50", cID);
            watchedQuartiles.second = true;
        }
        if (!watchedQuartiles.third && currentTime >= (0.75 * duration)) {
            sendData(userData, "video", "75", cID);
            watchedQuartiles.third = true;
        }
        if (!watchedQuartiles.fourth && currentTime >= (1.00 * duration)) {
            sendData(userData, "video", "100", cID);
            watchedQuartiles.fourth = true;
        }
    });
	}
};